// *******************************************************************
//Website:  http://wch.cn
//Email:    tech@wch.cn
//Author:   W.ch 2007.6
// *******************************************************************

/*****************CH423ȫԶʾɨӳ *************************/

#include <reg52.h>
#include <intrins.h>
#include <stdio.h>

#include "CH423IF.H"    // ޸ĸļӦӲ/Ƭͺŵ
//#include "CH423IF.C"

#define CH423_SYSON1    0x0417    //Զɨʾ

unsigned char CH423_buf[16];    //16ܵӳ󻺴
const unsigned char BCD_decode_tab[ 0x10 ] = { 0X3F, 0X06, 0X5B, 0X4F, 0X66, 0X6D, 0X7D, 0X07, 0X7F, 0X6F, 0X77, 0X7C, 0X58, 0X5E, 0X79, 0X71 };

void mDelaymS( unsigned char ms )    // ʱ
{
    unsigned short i;
    while ( ms -- ) 
    {
        for ( i = 0; i != 1000; i++ );
    }
}

void mDelayS( unsigned char s )    // ʱ
{
    while ( s -- ) 
    {
        mDelaymS( 250 );
        mDelaymS( 250 );
        mDelaymS( 250 );
        mDelaymS( 250 );
    }
}

void CH423_buf_write( unsigned short cmd )    // CH423ݻ߲Զӳ
{
    if ( cmd & 0x1000 ) 
    {    // ݵ,Ҫݵӳ󻺳
        CH423_buf[ (unsigned char)( cmd >> 8 ) & 0x0F ] = (unsigned char)( cmd & 0xFF );    // ݵӦӳԪ
    }
    CH423_Write( cmd );    // 
}

void CH423_buf_index( unsigned char index, unsigned char dat )    // CH423ָ,Զӳ
{    // index Ϊ,ЧֵΪ015,ֱӦDIG0DIG15
    unsigned short cmd;
    CH423_buf[ index ] = dat;    // ݵӦӳԪ
    cmd = ( CH423_DIG0 + ( ( unsigned short)index << 8 ) ) | dat;    // ɲ
    CH423_Write( cmd );    // 
}

void CH423_set_bit( unsigned char bit_addr )    // λ
{
    unsigned char byte_addr;
    byte_addr = ( bit_addr>>3 ) & 0x0F;
    CH423_buf_index( byte_addr, CH423_buf[byte_addr] | ( 1<<( bit_addr&0x07 ) ) );
}

void CH423_clr_bit( unsigned char bit_addr )    // λϨ
{
    unsigned char byte_addr;
    byte_addr = ( bit_addr>>3 ) & 0x0F;
    CH423_buf_index( byte_addr, CH423_buf[byte_addr] & ~(1<<(bit_addr&0x07 ) ) );
}

void LEFTMOV()    //                    
{
    unsigned short i;
    for ( i = 0x000F; i >= 0x0001; i-- )
    {
        CH423_buf_index( i, CH423_buf[i-1] ); 
    }
    CH423_Write( 0x1000 );
}

void LEFTCYC()    // ѭ
{
    unsigned short i, j;
    j = CH423_buf[15];
    for ( i = 0x000F; i >= 0x0001; i-- )
    {
        CH423_buf_index( i,CH423_buf[i-1] ); 
    } 
        CH423_Write( 0x1000 | j );
}

void RIGHTMOV()    // 
{
    unsigned short i;
    for ( i = 0x0000; i < 0x000F; i++ )
    {
        CH423_buf_index( i,CH423_buf[i+1] ); 
    }
    CH423_Write( 0x1F00 );
}

void RIGHTCYC()    // ѭ
{
    unsigned char i, j;
    j=CH423_buf[0];
    for ( i = 0x0000; i < 0x000F; i++ )
    {
        CH423_buf_index( i, CH423_buf[i+1] ); 
    }
    CH423_Write( 0x1F00 | j );
}

void TWINKLE( unsigned char dig_number )    // ˸
{
    unsigned char old;
    old = CH423_buf[dig_number & 0x0F];
    CH423_buf_index( dig_number, 0x00 );
    mDelaymS( 250 );
    CH423_buf_index( dig_number, old );
    mDelaymS( 250 );
}

main()
{
    unsigned char i, j;
    mDelaymS( 50 );
    for ( i = 0; i < 16; i ++ ) CH423_buf_index( i, 0 );    // ΪCH423λʱʾݣԸտΪգٿʾ
    CH423_buf_write( CH423_SYSON1 );    // ʾ
    // ҪˢʾݣôֻҪִ1716ݼԼ1ʾ
    CH423_buf_write( CH423_DIG15 | BCD_decode_tab[15] );    // ʾBCD1
    CH423_buf_write( CH423_DIG14 | BCD_decode_tab[14] );
    CH423_buf_write( CH423_DIG13 | BCD_decode_tab[13] );
    CH423_buf_write( CH423_DIG12 | BCD_decode_tab[12] );
    CH423_buf_write( CH423_DIG11 | BCD_decode_tab[11] );    // ʾBCD1
    CH423_buf_write( CH423_DIG10 | BCD_decode_tab[10] );
    CH423_buf_write( CH423_DIG9  | BCD_decode_tab[9] );
    CH423_buf_write( CH423_DIG8  | BCD_decode_tab[8] );
    CH423_buf_write( CH423_DIG7  | BCD_decode_tab[7] );
    CH423_buf_write( CH423_DIG6  | BCD_decode_tab[6] );
    CH423_buf_write( CH423_DIG5  | BCD_decode_tab[5] );    // ʾBCD1
    CH423_buf_write( CH423_DIG4  | BCD_decode_tab[4] );
    CH423_buf_write( CH423_DIG3  | BCD_decode_tab[3] );
    CH423_buf_write( CH423_DIG2  | BCD_decode_tab[2] );
    CH423_buf_write( CH423_DIG1  | BCD_decode_tab[1] );
    CH423_buf_write( CH423_DIG0  | BCD_decode_tab[0] );
    while ( 1 ) 
    {    // ʾ
        for( i = 0; i < 16; i++ ) CH423_buf_index( i, 0xFF );    // ȫ
        mDelayS( 1 );
        for( i = 0; i < 16; i++ ) CH423_buf_index( i, 0x00 );    // ȫ
        mDelaymS( 500 );
        for ( j = 0; j != 8; j ++ ) 
        {    // ɨÿΣʾ
            for ( i = 0; i != 16; i++ ) CH423_buf_index( i, 1<<j );
            mDelaymS( 250 );
        }
        for( i = 0; i < 16; i++ ) CH423_buf_index( i, 0xFF );    // ȫ
        mDelaymS( 500 );
        for( i = 0; i < 16; i++ ) CH423_buf_index( i, BCD_decode_tab[i] );    // ʾBCD0123456789AbcdEF
        mDelaymS( 500 );
        for( i = 0; i != 8; i++ )    // ѭ
        {
            LEFTCYC(); mDelaymS( 250 );
        }
        for( i = 0;i != 8; i++ )    // ѭ
        {
            RIGHTCYC(); mDelaymS( 250 );
        }
        for(i = 0; i != 8; i++)    // 
        {
            LEFTMOV(); mDelaymS( 250 );
        }
        for( i = 0; i != 8; i++)    // 
        {
             RIGHTMOV(); mDelaymS(250);
        }
        for( i = 0; i < 16; i++ ) CH423_buf_index( i, BCD_decode_tab[i] );    // ʾBCD0123456789abcdEF
        mDelaymS( 250 );
        for( i = 0; i != 16; i++ )    // ˸
        {
            TWINKLE( i ); mDelaymS( 100 );
        }
        for( i = 0; i < 16; i++ ) CH423_buf_index( i, 0x00 );    // ȫ
        mDelaymS( 250 );
        for( i = 0; i != 16*8; i++ )    // öλ 
        {
            CH423_set_bit( i );
            mDelaymS( 100 );
        }
        mDelaymS( 500 );
        for( i = 0; i != 16*8; i++ )    // λ
        {
            CH423_clr_bit( i );
            mDelaymS( 100 );
        }
        mDelaymS( 500 );
    }
}
