// *******************************************************************
//Website:  http://wch.cn
//Email:    tech@wch.cn
//Author:   W.ch 2007.6
// *******************************************************************
// Ƭѡ뷽ʽ16/128ֻLEDܣMCS51Ƭӣʹöʱʱлʾ

#include <reg52.h>
#include <intrins.h>
#include <stdio.h>
#pragma NOAREGS    // MCS51жϷеCH423ӳô˱ѡ

#include "CH423IF.H"    // ޸ĸļӦӲ/Ƭͺŵ
//#include "CH423IF.C"

const unsigned char BCD_decode_tab[ 29 ] = { 0X3F, 0X06, 0X5B, 0X4F, 0X66, 0X6D, 0X7D, 0X07, 0X7F, 0X6F, 0X77, 0X7C, 0X58, 0X5E, 0X79, 0X71, 0x00, 0x46, 0x40, 0x41, 0x39, 0x0F, 0x08, 0x76, 0x38, 0x73, 0x80, 0xFF, 0x00 };
#define SPACE             0x10       // ո     

unsigned char CH423_buf[ 16 ];    // 16ܵӳ󻺴

void mDelaymS( unsigned char ms )    // ʱ
{
    unsigned short i;
    while ( ms -- )
    {
    for( i = 0; i != 1000; i++ );
    }
}

void mDelayS( unsigned char s )    // ʱ
{
    while ( s -- ) 
    {    
        mDelaymS( 250 );
        mDelaymS( 250 );
        mDelaymS( 250 );
        mDelaymS( 250 );
    }
}

void CH423_buf_index( unsigned char index, unsigned char dat )  // CH423ָ,Զӳ
{
    if( index >= sizeof( CH423_buf ) ) index = 0;
    if( dat >= sizeof( BCD_decode_tab ) ) dat = SPACE;    // ݱСдո
    CH423_buf[index ] = BCD_decode_tab[ dat ];    // ݵӦӳԪ
}

void CH423_set_bit( unsigned char bit_addr )    // λ
{
    unsigned char byte_addr;
    byte_addr = ( bit_addr>>3 ) & 0x0F;
    CH423_buf[ byte_addr ] |= 1<<( bit_addr&0x07 );
}

void CH423_clr_bit( unsigned char bit_addr )    // λϨ
{
    unsigned char byte_addr;
    byte_addr = ( bit_addr>>3 ) & 0x0F;
    CH423_buf[ byte_addr ] &= ~ (1<<(bit_addr&0x07 ) );
}

void LEFTMOV()    //                    
{
    unsigned short i;
    for ( i = 0x000F; i >= 0x0001; i-- ) CH423_buf[ i ] = CH423_buf[ i - 1 ];
    CH423_buf[ 0x00 ] = 0x00;
}

void RIGHTMOV()    // 
{
    unsigned short i;
    for ( i = 0x0000; i < 0x000F; i++ ) CH423_buf[ i ] = CH423_buf[ i + 1 ];
    CH423_buf[ 0x0F ] = 0x00;
}

void TWINKLE( unsigned char dig_number )    // ˸
{
    unsigned char old;
    dig_number &= 0x0F;
    old = CH423_buf[ dig_number ];
    CH423_buf[ dig_number ] = 0x00;
    mDelaymS( 250 );
    CH423_buf[ dig_number ] = old;
    mDelaymS( 250 );
}

void mInitSTDIO( )
{
    TMOD = 0x10;    // T/C1ڶʱʽ1 
    TL1 = 0x30;
    TH1 = 0xf8;    // 24MHzԤüֵ, 1msʱ 
    TR1 = 1;       // T/C1ʼʱ 
    EA = 1;        // CPUж  
    ET1 = 1;       // T/C1ж 
}

void int1() interrupt 3    //ʱ1ж,ʱлʾ
{
    static unsigned char i = 0;
    TL1 = 0x30;
    TH1 = 0xf8;  /* 24MHzԤüֵ, 1msʱ */
    CH423_WriteByte( CH423_SET_IO_CMD + ( ( unsigned short ) i << 9 ) | CH423_buf[ i ] );    //  
    if( ++i >= 16 ) i = 0;
}

main()
{
    unsigned char i;
    mInitSTDIO( );
    mDelaymS(30);
    for( i = 0; i < 16; i++ ) CH423_buf_index( i, 0x10 );
    mDelaymS(10);
    CH423_WriteByte( CH423_SYS_CMD | BIT_DEC_H | BIT_DEC_L | BIT_IO_OE );    // ϵͳ
    mDelaymS( 250 );
    for( i = 0; i < 16; i++ ) CH423_buf_index( i, i );    // ʾ0123456789A, B, C, D, E, F
    mDelaymS( 250 );
    mDelaymS( 250 );
    for( i = 0; i < 16; i++ ) CH423_buf_index( i,0x10 );    // ʾո
    mDelaymS( 250 );
    for( i = 0; i != 16*8; i++ )    // öλ
    {
        CH423_set_bit( i );
        mDelaymS( 50 );
    }
    mDelaymS( 250 );
    mDelaymS( 250 );
    for( i = 0; i < 16; i++ ) CH423_buf_index( i,15-i );    // ʾFEDCBA98765, 4, 3, 2, 1, 0
    mDelaymS( 250 );
    mDelaymS( 250 );
    while( 1 ) {
	    mDelaymS( 10 );
    }
}
