/* *******************************************************************
 Website:  http://wch.cn
 Email:    tech@wch.cn
 Author:   W.ch 2007.6
 CH423 ӿӳ
**********************************************************************
 CH4232߽ӿڣֻҪ2I/OţI2C/IICʱ
 Ϊ˽Լʱ䣬ʵSCL/SDA֮ʱ
 ϣSCL·ãôֻҪSDA仯SCLͿκ;
 ϣSCLSDA·ãôؼȷSDAֻSCLΪ͵ƽڼ䷢仯SCLSDAʺΪʹ
     1SCLţֱ
     2SDAţʱ
          SCLΪ͵ƽôֱ
          SCLΪߵƽôȽSCL͵ƽٽSDASCLָΪߵƽ
*************************************************************************** */

#include "CH423IF.H"    // ޸ĸļӦӲ/Ƭͺŵ

void CH423_I2c_Start( void )    // ʼ
{
    CH423_SDA_SET;    // ʼź
    CH423_SDA_D_OUT;    // SDAΪ 
    CH423_SCL_SET;
    CH423_SCL_D_OUT;    // SCLΪ 
    DELAY_0_1US;
    CH423_SDA_CLR;    //ʼź
    DELAY_0_1US;      
    CH423_SCL_CLR;    //ǯסI2Cߣ׼ͻ 
}

void CH423_I2c_Stop( void )    // 
{
    CH423_SDA_CLR;
    DELAY_0_1US;
    CH423_SCL_SET;
    DELAY_0_1US;
    CH423_SDA_SET;    // I2C߽ź
    DELAY_0_1US;
}

void CH423_I2c_WrByte( unsigned char dat )    // дһֽ
{
    unsigned char i;
    for( i = 0; i != 8; i++ )    // 8λ
    {
        if( dat&0x80 ) { CH423_SDA_SET; }
        else { CH423_SDA_CLR; }
        DELAY_0_1US;
        CH423_SCL_SET;
        dat<<=1;
        DELAY_0_1US;    // ѡʱ
        CH423_SCL_CLR;
    }
    CH423_SDA_SET;
    DELAY_0_1US;
    CH423_SCL_SET;    // Ӧ
    DELAY_0_1US;
    CH423_SCL_CLR;
}

unsigned char CH423_I2c_RdByte( void )    // һֽ
{
    unsigned char dat,i;
    CH423_SDA_SET;
    CH423_SDA_D_IN;    // SDAΪ뷽 
    dat=0;
    for( i = 0; i != 8; i++ )    // 8λ
    {
        DELAY_0_1US;    // ѡʱ
        CH423_SCL_SET;
        DELAY_0_1US;    // ѡʱ
        dat<<=1;
        if(CH423_SDA_IN) dat++;    // 1λ
        CH423_SCL_CLR;
    }
    CH423_SDA_SET;
    DELAY_0_1US;
    CH423_SCL_SET;    // ЧӦ
    DELAY_0_1US;
    CH423_SCL_CLR;
    return(dat);
}

void CH423_Write( unsigned short cmd )    // д
{
    CH423_I2c_Start();    // 
    CH423_I2c_WrByte( ( ( unsigned char )( cmd>>7 ) & CH423_I2C_MASK ) | CH423_I2C_ADDR1 );
    CH423_I2c_WrByte( ( unsigned char ) cmd );    // 
    CH423_I2c_Stop();    //  
}

void CH423_WriteByte( unsigned short cmd )    // д
{
    CH423_I2c_Start();    // 
    CH423_I2c_WrByte( ( unsigned char )( cmd>>8 ) );
    CH423_I2c_WrByte( ( unsigned char ) cmd );    // 
    CH423_I2c_Stop();    //   
}

unsigned char CH423_ReadByte()    // ȡ
{
    unsigned char din;
    CH423_I2c_Start();    // 
    CH423_I2c_WrByte( CH423_RD_IO_CMD );    // ֵΪ0x4D
    din=CH423_I2c_RdByte();    // ȡ
    CH423_I2c_Stop();    // 
    return( din );
}
